unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellApi;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function StartAssociatedExe(FileName: string; var ErrorCode: Cardinal): Boolean;
var
 Prg,s: string;
 ProcessInfo: TProcessInformation;
 StartupInfo: TStartupInfo;
begin
 SetLength(Prg, MAX_PATH);
 Result:=false;
 ErrorCode:=FindExecutable(PChar(FileName), nil, PChar(Prg));
 //
 if ErrorCode>=32
 then
  begin
   SetLength(Prg, StrLen(PChar(Prg)));
   FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
   with StartupInfo do
    begin
     cb:=SizeOf(TStartupInfo);
     wShowWindow:=SW_SHOW;
    end;
   //
   // PChar(Format('%s %s', [Prg, FileName])
   s:=Format('%s %s', [Prg, FileName]);
   Result:=CreateProcess(nil, PChar(s), nil, nil,
    false, NORMAL_PRIORITY_CLASS, nil, nil, StartupInfo, ProcessInfo);
   // Wait for it to finish
   if Result
   then
    begin
     WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
     //    ..
     GetExitCodeProcess(ProcessInfo.hProcess, ErrorCode);
     CloseHandle(ProcessInfo.hProcess);
     CloseHandle(ProcessInfo.hThread);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 s: string;
 ErrorCode: Cardinal;
begin
 s:=ExtractFilePath(Application.ExeName)+'_test.doc';
 StartAssociatedExe(s, ErrorCode);
 ShellExecute(0,'open',PChar(s),'','',SW_SHOW);
 Sleep(1000);
 DeleteFile(s);
end;

end.
